config/routes.rb
Rails.application.routes.draw do
  resources :operational_systems
  resources :tools
  resources :projects
  resources :languages
  
  get "/users/login" => "login#index"
  post "/users/login" => "login#create"
  get "/users/logout" => "login#logout"
  resources :users

  root :to => "login#index"

	get 'auth/:provider/callback', to: 'omni_auth_login#create'
  get 'auth/failure', to: redirect('/')
  get 'signout', to: 'omni_auth_login#destroy'


end

app/models/language.rb
class Language < ActiveRecord::Base
	has_many :projects
end

app/controllers/languages_controller.rb
class LanguagesController < ApplicationController
  before_action :set_language, only: [:show, :edit, :update, :destroy]

  # GET /languages
  def index
    @languages = Language.all
   # @client = Project.find(:one ,1,  :params => {:api_key => 'a8b2141ce1264ca5e99e49e1cb37dbb589949bc910cc6d71a938c8db7f51136c'})
  end

  # GET /languages/1
  def show
  end

  # GET /languages/new
  def new
    @language = Language.new
  end

  # GET /languages/1/edit
  def edit
  end

  # POST /languages
  def create
    @language = Language.new(language_params)

    if @language.save
      redirect_to @language, notice: 'Language was successfully created.'
    else
      render :new
    end
  end

  # PATCH/PUT /languages/1
  def update
    if @language.update(language_params)
      redirect_to @language, notice: 'Language was successfully updated.'
    else
      render :edit
    end
  end

  # DELETE /languages/1
  def destroy
    @language.destroy
    redirect_to languages_url, notice: 'Language was successfully destroyed.'
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_language
      @language = Language.find(params[:id])
    end

    # Only allow a trusted parameter "white list" through.
    def language_params
      params.require(:language).permit(:name)
    end
end

app/helpers/languages_helper.rb
module LanguagesHelper
end

app/views/languages/_form.html.erb
<%= form_for(@language) do |f| %>
  <% if @language.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@language.errors.count, "error") %> prohibited this language from being saved:</h2>

      <ul>
      <% @language.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/languages/edit.html.erb
<h1>Editing Language</h1>

<%= render 'form' %>

<%= link_to 'Show', @language %> |
<%= link_to 'Back', languages_path %>

app/views/languages/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Languages</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @languages.each do |language| %>
      <tr>
        <td><%= language.name %></td>
        <td><%= link_to 'Show', language %></td>
        <td><%= link_to 'Edit', edit_language_path(language) %></td>
        <td><%= link_to 'Destroy', language, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Language', new_language_path %>

app/views/languages/new.html.erb
<h1>New Language</h1>

<%= render 'form' %>

<%= link_to 'Back', languages_path %>

app/views/languages/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @language.name %>
</p>

<%= link_to 'Edit', edit_language_path(@language) %> |
<%= link_to 'Back', languages_path %>